// Copyright 2008 - SIsécurité
//
// Incrementer algorithm from Bob the Butcher.
//
#include <string.h>
#include "charset.h"

unsigned char incrementer[0x100] __attribute__ ((aligned (16)));


static unsigned int FillIncrementer(const unsigned char *charset,
				    unsigned int index) {
  unsigned int i;

  for (i = 0; charset[i] != '\0'; ++i)
    index = incrementer[index] = charset[i];

  return index;
}


void IncrementerInit(unsigned int type_charset) {
  unsigned int index = 0;

  memset(incrementer, 0, sizeof(incrementer));

  if (type_charset & UPPER_ALPHA)
    index = FillIncrementer(upperalpha, index);

  if (type_charset & LOWER_ALPHA)
    index = FillIncrementer(loweralpha, index);

  if (type_charset & NUMERIC)
    index = FillIncrementer(numeric, index);

  if (type_charset & SYMBOL14)
    index = FillIncrementer(symbol14, index);

  if (type_charset & ACCENT4)
    index = FillIncrementer(accent4, index);
}
