// Copyright 2008 - SIsécurité
//
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "nt_spu.h"
#include "tests.h"


// Tests
const fmt_tests_t tests[] = {
  {"1880aa53a397aa96beda35af3481a3d5", "CeLl-bE"},
  {"8846f7eaee8fb117ad06bdd830b7586c", "password"},
  {"0cb6948805f797bf2a82807973b89537", "test"},
  {"31d6cfe0d16ae931b73c59d7e0c089c0", ""},
  {NULL, NULL}
};


// Test function generate deterministic passwords
int TestGeneratePlainText(unsigned char *dst,
			  const unsigned int num,
			  const unsigned int len,
			  void *n __attribute__ ((unused))) {
  assert((num == 8) && !(num % NUM_INTER_PT));

  memcpy(dst, tests[0].plaintext, len);
  memcpy(dst + len, tests[1].plaintext, len);
  memcpy(dst + 2 * len, tests[2].plaintext, len);
  memcpy(dst + 3 * len, tests[3].plaintext, len);
  memcpy(dst + 4 * len, tests[0].plaintext, len);
  memcpy(dst + 5 * len, tests[1].plaintext, len);
  memcpy(dst + 6 * len, tests[2].plaintext, len);
  memcpy(dst + 7 * len, tests[3].plaintext, len);

  // If num hadn't been a multiple of NUM_INTER_PT we would
  // had filled missing slots with duplicated last ciphertext.

  // Convention:
  //   return -1 on error
  return num;
}
