#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
#include "spu_common.h"
#include "wordlist.h"


// Function taken from JtR
static char *fgetl(char *s, const int size, FILE *stream) {
  char *res, *pos;
  int c;

  if ((res = fgets(s, size, stream))) {
    if (!*res) return res;

    pos = res + strlen(res) - 1;
    if (*pos == '\n') {
      *pos = 0;
      if (pos > res)
	if (*--pos == '\r') *pos = 0;
    } else
      if ((c = getc(stream)) == '\n') {
	if (*pos == '\r') *pos = 0;
      } else
	while (c != EOF && c != '\n')
	  c = getc(stream);
  }

  return res;
}


FILE* WordListOpen(const char *pathname) {
  FILE *f;

  f = fopen(pathname, "r");
  if (f == NULL)
    ExitOnError("fdopen failure.");
  return f;
}


void WordListClose(void *p_f) {
  FILE *f = (FILE *) p_f;
  int rc;

  rc = fclose(f);
  if (rc < 0)
    perror("Unable to close file.\n");
}


int WordListGeneratePlainText(unsigned char *dst,
			      const unsigned int num,
			      const unsigned int len,
			      void *p_f) {
  FILE *f = (FILE *) p_f;
  unsigned int count = 0;

  while (fgetl((char *) dst, len, f) && count < num) {

    // Discard optional comment
    if (*dst == '#')
      if (!strncmp((char *) dst, "#!comment", 9))
	continue;

    // fixme: debug
    //printf("%s\n", dst);

    dst += len;
    count++;
  }

  // In case where count < num, remaining bytes of dst will
  // contain garbage data, but it shouln't be a matter.

  return count;
}
